<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en">
<head>
	<title>CarbonPHP Documentation</title>
	<style type="text/css">
		* {
			margin: 0;
			padding: 0;
		}

		html {
			font-family: "Lucida Sans Unicode", "Lucida Grande";
			font-size: 14px;
		}

		body {
			background: #fff;
			color: #666;
		}

		h1 {
			font-size: 15px;
			font-weight: bold;
			margin: 0 0 5px 0;
		}

		h2 {
			font-size: 13px;
			font-weight: bold;
			margin: 5px 0 5px 0;
		}

		ol, ul {
			margin: 10px 0 10px 0;
			list-style-position: inside;
		}

		p {
			margin: 5px 0 5px 0;
		}

		.content {
			border: 1px dotted #444;
			margin: 10px;
			padding: 10px;
			text-align: justify;
			width: 700px;
		}

		.example {
			border: 1px solid #ccc;
			background: #eee;
			margin: 10px;
			padding: 10px;
			text-align: left;
		}
	</style>
</head>

<body>
	<div class="content">
		<h1>Active Record Class</h1>

		<p>CarbonPHP implements a modified version of the active record design pattern.  This pattern allows
		information to be retrieved, inserted, and updated in your database with minimal coding.  In some cases
		only one or two lines of code are needed.  CarbonPHP does not require that each database table be its own
		class file.  It instead provides a more simpler interface.</p>

		<p>Beyond the simplicity a major benefit of using the active record class is that it will allow you to
		create database independent applications, since query syntax is generated by each database driver.</p>
	</div>

	<div class="content">
		<h1>Selecting Data</h1>

		<p>The following examples show you how you can build <b>SELECT</b> statements for getting data from a
		database.</p>
	</div>

	<div class="content">
		<h1>$this->db-get()</h1>

		<p>This method runs the query and returns the results object.  This can be used itself to retrieve all the
		rows from a table.</p>

		<div class="example">
			$query = $this->db->get('some_table');<br />
			<br />
			// This produces: SELECT * FROM some_table
		</div>

		<p>The second and third parameters allow you to specify a limit and offset.</p>

		<div class="example">
			$query = $this->db->get('some_table', 10, 20);<br />
			<br />
			// This produces: SELECT * FROM some_table LIMIT 20, 10
		</div>
	</div>

	<div class="content">
		<h1>$this->db->getw_here()</h1>

		<p>This method is identical to the above one except that it allows you to add a 'where' clause to the
		statement, instead of using <b>$this->db->where()</b>.</p>

		<div class="example">
			$query = $this->db->get_where('some_table', array('id' => $id), $limit, $offset);
		</div>

		<p>The <b>where()</b> method is outlined below.</p>
	</div>

	<div class="content">
		<h1>$this->db->select()</h1>

		<p>This method allows you to write the SELECT part of your queries.</p>

		<div class="example">
			$this->db->select('title, author, post');<br />
			<br />
			$query = $this->db->get('some_table');<br />
			<br />
			// This produces: SELECT title, author, post FROM some_table
		</div>

		<p>If you are selecting all (*) from a table, you can omit this method.</p>

		<p><b>$this->db->select()</b> accepts an optional second parameter.  If this parameter is set to false, CarbonPHP will
		try to not protect your field or table names with backticks.  This is useful if you need a compound select statement.</p>
	</div>

	<div class="content">
		<h1>$this->db->select_max()</h1>
		
		<p>This writes a "SELECT MAX(field)" portion of your query.  You can optionally include a second
		parameter to rename the resulting field.</p>

		<div class="example">
			$this->db->select_max('age');<br />
			$query = $this->db->get('members');<br />
			// gives SELECT MAX(age) as age FROM members<br />
			<br />
			$this->db->select_max('age', 'member_age');<br />
			$query = $this->db->get('members');<br />
			// gives SELECT MAX(age) as member_age FROM members
		</div>
	</div>

	<div class="content">
		<h1>$this->db->select_min()</h1>

		<p>This writes a "SELECT MIN(field)" portion of your query.  You can optionally include a second
		parameter to rename the resulting field.</p>

		<div class="example">
			$this->db->select_min('age');<br />
			$query = $this->db->get('members');<br />
			// gives SELECT MIN(age) as age FROM members<br />
			<br />
			$this->db->select_min('age', 'member_age');<br />
			$query = $this->db->get('members');<br />
			// gives SELECT MIN(age) as member_age FROM members
		</div>
	</div>

	<div class="content">
		<h1>$this->db->select_avg()</h1>

		<p>This writes a "SELECT AVG(field)" portion of your query.  You can optionally include a second
		parameter to rename the resulting field.</p>

		<div class="example">
			$this->db->select_avg('age');<br />
			$query = $this->db->get('members');<br />
			// gives SELECT AVG(age) as age FROM members<br />
			<br />
			$this->db->select_avg('age', 'member_age');<br />
			$query = $this->db->get('members');<br />
			// gives SELECT AVGage) as member_age FROM members
		</div>
	</div>

	<div class="content">
		<h1>$this->db->select_sum()</h1>

		<p>This writes a "SELECT SUM(field)" portion of your query.  You can optionally include a second
		parameter to rename the resulting field.</p>

		<div class="example">
			$this->db->select_sun('age');<br />
			$query = $this->db->get('members');<br />
			// gives SELECT SUM(age) as age FROM members<br />
			<br />
			$this->db->select_min('age', 'member_age');<br />
			$query = $this->db->get('members');<br />
			// gives SELECT SUM(age) as member_age FROM members
		</div>
	</div>

	<div class="content">
		<h1>$this->db->from()</h1>

		<p>This method allows you to write the FROM part of your queries.</p>

		<div class="example">
			$this->db->select('title, author, post');<br />
			$this->db->from('some_table');<br />
			$this->db->get();<br />
			<br />
			// This produces: SELECT title, author, post FROM some_table
		</div>

		<p>As shown above the FROM part of your query can be passed in the <b>get()</b> method.</p>
	</div>

	<div class="content">
		<h1>$this->db->join()</h1>

		<p>This method allows you to write the JOIN parts of your queries.</p>

		<div class="example">
			$this->db->select('*');<br />
			$this->db->from('blogs');<br />
			$this->db->join('comments', 'comments.id = blogs.id');<br />
			<br />
			$query = $this->db->get();<br />
			<br />
			// This produces:<br />
			// SELECT * FROM blogs<br />
			// JOIN comments ON comments.id = blogs.id
		</div>

		<p>Multiple function call can be made if you need several joins in one query.</p>

		<p>If you need something other than a natural JOIN you can specify it via the third parameter of the function.
		Options are, left, right, outer, inner, left outer, and right outer.</p>

		<div class="example">
			$this->db->join('comments', 'comments.id = blogs.id', '<b>left</b>');<br />
			<br />
			// This produces: LEFT JOIN comments ON comments.id = blogs.id
		</div>
	</div>

	<div class="content">
		<h1>$this->db->where()</h1>

		<p>This method enables you to create WHERE clauses using one of four methods.</p>

		<ol>
			<li>
				<b>Simple key/value array method</b>

				<div class="example">
					$this->db->where('name', $name);<br />
					<br />
					// This produces: WHERE name = 'John';
				</div>

				<p>You may notice that the equals sign is added for you.</p>

				<p>You can use multiple method calls to chain together with AND between them.</p>

				<div class="example">
					$this->db->where('name' => $name);<br />
					$this->db->where('title' => $title);<br />
					$this->db->where('status' => $status);<br />
					<br />
					// This produces: WHERE name = 'John' AND title = 'Student' AND status = 'active'
				</div>
			</li>

			<li>
				<b>Custom key/value array method</b>

				<p>You can include an operator in the first parameter in order to control how the comparsion occurs.</p>

				<div class="example">
					$this->db->where('name !=', $name);<br />
					$this->db->where('id <', $id);<br />
					<br />
					// This produces: WHERE name != 'John' AND id < 4
				</div>
			</li>

			<li>
				<b>Associative array method</b>

				<div class="example">
					$array = array('name' => $name, 'title' => $title, 'status' => $status);<br />
					<br />
					$this->db->where($array);<br />
					<br />
					// This produces: WHERE name = 'John' AND title = 'Student'  AND status 'active'
				</div>

				<p>You can include your own operators using this method as well.</p>

				<div class="example">
					$array = array('name !=' => $name, 'id <' => $id);<br />
					<br />
					$this->db->where($array);
				</div>
			</li>

			<li>
				<b>Custom string</b>

				<p>You can write your own WHERE clauses manually.</p>

				<div class="example">
					$where = "name='John' AND status='Student' OR status='active'";<br />
					<br />
					$this->db->where($where);
				</div>
			</li>
		</ol>
	</div>

	<div class="content">
		<h1>$this->db->or_where()</h1>

		<p>This method is identical to the above one, except that multiple instances are joined by OR.</p>

		<div class="example">
			$this->db->where('name !=', $name);<br />
			$this->db->or_where('id >', $id);<br />
			<br />
			// This produces: WHERE name != 'John' OR id > 500
		</div>
	</div>

	<div class="content">
		<h1>$this->db->where_in()</h1>

		<p>This generates a WHERE field IN ('item', 'item') SQL query joined with an AND if appropriate.</p>

		<div class="example">
			$names = array('Frank', 'Tom', 'Bob');<br />
			$this->db->where_in('username', $names);<br />
			// gives AND WHERE username IN ('Frank', 'Tom', 'Bob');
		</div>
	</div>

	<div class="content">
		<h1>$this->db->or_where_in()</h1>

		<p>This generates a OR WHERE field IN ('item', 'item') SQL query joined with an OR if appropriate.</p>

		<div class="example">
			$names = array('Frank', 'Tom', 'Bob');<br />
			$this->db->or_where_in('username', $names);<br />
			// gives OR WHERE username IN ('Frank', 'Tom', 'Bob');
		</div>
	</div>

	<div class="content">
		<h1>$this->db->where_not_in()</h1>

		<p>This generates a WHERE field NOT IN ('item', 'item') SQL query joined with an AND if appropriate.</p>

		<div class="example">
			$names = array('Frank', 'Tom', 'Bob');<br />
			$this->db->where_not_in('username', $names);<br />
			// gives WHERE username NOT IN ('Frank', 'Tom', 'Bob');
		</div>
	</div>

	<div class="content">
		<h1>$this->db->or_where_not_in()</h1>

		<p>This generates a OR WHERE field NOT IN ('item', 'item') SQL query joined with an OR if appropriate.</p>

		<div class="example">
			$names = array('Frank', 'Tom', 'Bob');<br />
			$this->db->or_where_not_in('username', $names);<br />
			// gives OR WHERE username NOT IN ('Frank', 'Tom', 'Bob');
		</div>
	</div>

	<div class="content">
		<h1>$this->db->like()</h1>

		<p>This method enables you to generate LIKE clauses, these are useful for doing searches.</p>

		<ol>
			<li>
				<b>Simple key/value array method</b>

				<div class="example">
					$this->db->like('title', $match);<br />
					<br />
					// This produces: WHERE title LINK '%match%'
				</div>

				<p>If you use multiple method calls they will be joined with AND between them.</p>

				<div class="example">
					$this->db->like('title', $match);<br />
					$this->db->like('body', $match);<br />
					<br />
					// This produces: WHERE title LIKE '%match%' AND body LIKE '%match%'
				</div>

				<p>If you want to control where the wildcard (%) is placed, you can use an optioanl third argument.
				Your options are 'before', 'after', and 'both'.  The default is 'both'.</p>

				<div class="example">
					$this->db->like('title', 'match', 'before');<br />
					// gives WHERE title LIKE '%match'<br />
					<br />
					$this->db->like('title', 'match', 'after');<br />
					// gives WHERE title LIKE 'match%'<br />
					<br />
					$this->db->like('title', 'match', 'both');<br />
					// gives WHERE title LIKE '%match%'
				</div>
			</li>

			<li>
				<b>Associative array method</b>

				<div class="example">
					$array = array('title' => $match, 'page1' => $match, 'page2' => $match);<br />
					<br />
					$this->db->like($array);<br />
					<br />
					// This produces: WHERE title LIKE '%match%' AND page1 LIKE '%match%' AND 'page2' LIKE '%match%'
				</div>
			</li>
		</ol>
	</div>

	<div class="content">
		<h1>$this->db->or_like()</h1>

		<p>This method is identical to the above one except that multiple calls will be joined with OR.</p>

		<div class="example">
			$this->db->like('title', $match);<br />
			$this->db->or_like('body', $match);<br />
			<br />
			// This produces: WHERE title LIKE '%match%' OR body LIKE '%match%'
		</div>
	</div>

	<div class="content">
		<h1>$this->db->not_like()</h1>

		<p>This function is identical to <b>like()</b> except that it generates NOT LIKE statements.</p>

		<div class="example">
			$this->db->not_like('title', 'match');<br />
			// gives WHERE title NOT LIKE %match%
		</div>
	</div>

	<div class="content">
		<h1>$this->db->or_not_like()</h1>

		<p>This function is identical to <b>not_like()</b> except that multiple instances are joined by OR.</p>
		
		<div class="example">
			$this->db->like('title', 'match');<br />
			$this->db->or_not_like('body', 'match');<br />
			// gives WHERE title LIKE %match% OR body NOT LIKE %match%
		</div>
	</div>

	<div class="content">
		<h1>$this->db->group_by()</h1>

		<p>This method allows you to write GROUP BY parts of your queries.</p>

		<div class="example">
			$this->db->groupby('title');<br />
			<br />
			// This produces: GROUP BY title
		</div>

		<p>You can also pass an array of multiple values.</p>

		<div class="example">
			$this->db->groupby(array('title', 'author'));<br />
			<br />
			// This produces: GROUP BY title, author
		</div>
	</div>

	<div class="content">
		<h1>$this->db->distinct()</h1>
		
		<p>Adds the DISTINCT keyword to a query.</p>

		<div class="example">
			$this->db->distinct();<br />
			$this->db->get('table');<br />
			// gives SELECT DISTINCT * FROM table
		</div>
	</div>

	<div class="content">
		<h1>$this->db->having()</h1>

		<p>This method allows you to write the HAVING parts of your queries.</p>

		<div class="example">
			$this->db->having('user_id = 3');<br />
			<br />
			// This produces: HAVING 'user_id = 3'
		</div>

		<p>You can also pass an array of multiple values to the method.</p>

		<div class="example">
			$this->db->having(array('title =' => 'Title', 'id <' => $id));<br />
			<br />
			// This produces: HAVING title ='Title', 'id < 35'
		</div>
	</div>

	<div class="content">
		<h1>$this->db->or_having()</h1>
		
		<p>Identical to <b>having()</b> only it separates multiple clauses with OR.</p>
	</div>

	<div class="content">
		<h1>$this->db->order_by()</h1>

		<p>This method lets you set an ORDER BY clause.  The first parameter contains the name of the column you
		would like to order by.  The second parameter allows you to set the direction of the result.  The options
		are <b>asc</b>, <b>desc</b>, or <b>RAND()</b>.</p>

		<div class="example">
			$this->db->order_by('title', 'desc');<br />
			<br />
			// This produces: ORDER BY title DESC
		</div>

		<p>You can also pass your own string in the first parameter.</p>

		<div class="example">
			$this->db->order_by('title desc, name asc');<br />
			<br />
			// This produces: ORDER BY title DESC, name ASC
		</div>
	</div>

	<div class="content">
		<h1>$this->db->limit()</h1>

		<p>This method lets you limit the number of rows that you would like returned.</p>

		<div class="example">
			$this->db->limit(10);<br />
			<br />
			// This produces: LIMIT 10
		</div>

		<p>The second parameter lets you specify a result offset.</p>

		<div class="example">
			$this->db->limit(10, 20);<br />
			<br />
			// This produces: LIMIT 20, 10
		</div>
	</div>

	<div class="content">
		<h1>$this->db->count_all_results()</h1>
		
		<p>This allows you to determine the number of rows in a given Active Record query.  Queries will accept
		Active Record restrictors such as <b>where()</b>, <b>or_where()</b>, <b>like()</b>, and </b>or_like()</b>, etc.</p>

		<div class="example">
			echo $this->db->count_all_results('my_table');<br />
			// gives an integer like 25<br />
			<br />
			$this->db->like('title', 'match');<br />
			$this->db->from('my_table');<br />
			echo $this->db->count_all_results();<br />
			// gives an integer like 17
		</div>
	</div>

	<div class="content">
		<h1>$this->db->count_all()</h1>

		<p>This method allows you to determine the number of rows in the table.</p>

		<div class="example">
			$this->db->count_all('some_table');<br />
		</div>
	</div>

	<div class="content">
		<h1>Inserting Data</h1>

		<p>These methods provide an interface for inserting data into a database.</p>
	</div>

	<div class="content">
		<h1>$this->db->insert()</h1>

		<p>This method generates an insert string based on the data you supply, and runs the query.  You can either
		either pass an array or an object to the method.</p>

		<div class="example">
			$data = array(<br />
			&nbsp;&nbsp;&nbsp;&nbsp;'title' => 'My Title',<br />
			&nbsp;&nbsp;&nbsp;&nbsp;'author' => 'My Author',<br />
			&nbsp;&nbsp;&nbsp;&nbsp;'date' => 'My Date'<br />
			);<br />
			<br />
			$this->db->insert('some_table', $data);<br />
			<br />
			// This produces: INSERT INTO some_table (title, author, date) VALUES ('My Title, 'My Author', 'My Date')
		</div>

		<p>The first parameter will contain the table name, the second parameter is an array of values.</p>

		<div class="example">
			/*<br />
			class MyClass<br />
			&#123;<br />
			&nbsp;&nbsp;&nbsp;&nbsp;public $title = 'My Title';<br />
			&nbsp;&nbsp;&nbsp;&nbsp;public $content = 'Content';<br />
			&nbsp;&nbsp;&nbsp;&nbsp;public $date = 'My Date';<br />
			&#125;<br />
			*/<br />
			<br />
			$object = new MyClass();<br />
			<br />
			$this->db->insert('some_table', $object);<br />
			<br />
			// This produces: INSERT INTO some_table (title, content, date) VALUE ('My Title', 'Content', 'My Date')
		</div>

		<p>The first parameter is the table name, and the second parameter is an object with member variables.</p>
	</div>

	<div class="content">
		<h1>$this->db->set()</h1>

		<p>This method allows you to set values for INSERT and UPDATE queries.</p>

		<p>This method can be used instead of passing an array directly to the <b>insert()</b> or <b>update()</b>
		methods.</p>

		<div class="example">
			$this->db->set('name', $name);<br />
			$this->db->insert('some_table');<br />
			<br />
			// This produces: INSERT INTO some_table (name) VALUES ('{$name}')
		</div>

		<p>This method allows you to call it multiple times and will correctly build the query based on whether you
		are doing an INSERT or UPDATE.</p>

		<div class="example">
			$this->db->set('name', $name);<br />
			$this->db->set('title', $title);<br />
			$this->db->set('date', $date);<br />
			$this->db->insert('some_table');
		</div>

		<p>You can also pass an associative array to the method.</p>

		<div class="example">
			$array = array('name' => $name, 'title' => $title, 'date' => $date);<br />
			<br />
			$this->db->set($array);<br />
			$this->db->insert('some_table');
		</div>

		<p>You can also pass an object to the method.</p>

		<div class="example">
			/*<br />
			class MyClass<br />
			&#123;<br />
			&nbsp;&nbsp;&nbsp;&nbsp;public $title = 'My Title';<br />
			&nbsp;&nbsp;&nbsp;&nbsp;public $content = 'Content';<br />
			&nbsp;&nbsp;&nbsp;&nbsp;public $date = 'My Date';<br />
			&#125;<br />
			*/<br />
			<br />
			$object = new MyClass();<br />
			<br />
			$this->db->set($object);<br />
			$this->db->insert('some_table');
		</div>
	</div>

	<div class="content">
		<h1>Updating Data</h1>

		<p>These methods provide an interface for updating data in a database.</p>
	</div>

	<div class="content">
		<h1>$this->db->update()</h1>

		<p>This method generates an update string and runs the query based on the data you supply.  You can pass an
		array or an object to the method.</p>

		<div class="example">
			$data = array(<br />
			&nbsp;&nbsp;&nbsp;&nbsp;'title' => $title,<br />
			&nbsp;&nbsp;&nbsp;&nbsp;'author' => $author,<br />
			&nbsp;&nbsp;&nbsp;&nbsp;'date' => $date<br />
			);<br />
			<br />
			$this->db->where('id', $id);<br />
			$this->db->update('some_table', $data);<br />
			<br />
			// This produces:<br />
			// UPDATE some_table<br />
			// SET title = '{$title}', name = '{$name}', date = '{$date}'<br />
			// WHERE id = $id
		</div>

		<p>You can also choose to supply an object to the method.</p>

		<div class="example">
			/*<br />
			class MyClass<br />
			&#123;<br />
			&nbsp;&nbsp;&nbsp;&nbsp;public $title = 'My Title';<br />
			&nbsp;&nbsp;&nbsp;&nbsp;public $content = 'Content';<br />
			&nbsp;&nbsp;&nbsp;&nbsp;public $date = 'My Date';<br />
			&#125;<br />
			*/<br />
			<br />
			$this->db->where('id', $id);<br />
			$this->db->update('some_table');<br />
			<br />
			// This produces:<br />
			// UPDATE some_table<br />
			// SET title = '{$title}', name = '{$name}', date = '{$date}'<br />
			// WHERE id = $id
		</div>

		<p>You will notice the use of the <b>where()</b> method, enabling you to set the WHERE clause.  You can
		optionally pass this information directly into the update method as a string.</p>

		<div class="example">
			$this->db->update('some_table', $data, 'id = 4');
		</div>

		<p>You can also choose to pass an array to the method.</p>

		<div class="example">
			$this->db->update('some_table', $data, array('id' => $id));
		</div>

		<p>You can also use the <b>set()</b> method described above when performing updates.</p>
	</div>

	<div class="content">
		<h1>Deleting Data</h1>

		<p>These methods provide an interface for deleting data from databases.</p>
	</div>

	<div class="content">
		<h1>$this->db->delete()</h1>

		<p>This method generates a DELETE SQL string and runs the query.</p>

		<div class="example">
			$this->db->delete('some_table', array('id' => $id));<br />
			<br />
			// This produces:<br />
			// DELETE FROM some_table<br />
			// WHERE id = $id
		</div>

		<p>The first parameter is the table name, the second parameter is the where clause.  You can also use
		the <b>where()</b> or <b>orwhere()</b> methods instead of passing the data.</p>

		<div class="example">
			$this->db->where('id', $id);<br />
			$this->db->delete('some_table');<br />
			<br />
			// This produces:<br />
			// DELETE FROM some_table<br />
			// WHERE id = $id
		</div>
	</div>

	<div class="content">
		<h1>$this->db->empty_table()</h1>

		<p>This generates a delete SQL query and runs the query.</p>

		<div class="example">
			$this->db->empty_table('my_table');<br />
			// gives DELETE FROM my_table
		</div>
	</div>

	<div class="content">
		<h1>$this->db->truncate()</h1>
		
		<p>This generates a truncate SQL query and runs the query.</p>
		
		<div class="example">
			$this->db->from('my_table');<br />
			$this->db->truncate();<br />
			// or <br />
			$this->db->truncate('my_table');<br />
			// gives TRUNCATE my_table
		</div>

		<p><i>Note:</i> if the TRUNCATE command is not available, <b>truncate()</b> will execute as DELETE FROM table.</p>
	</div>

	<div class="content">
		<h1>Method Chaining</h1>

		<p>Method chaining allows you to simplify your syntax by connecting multiple methods.</p>

		<div class="example">
			$this->db->select('title')->from('some_table')->where('id', $id)->limit(10, 20);<br />
			<br />
			$query = $this->db->get();
		</div>
	</div>

	<div class="content">
		<h1>Active Record Caching</h1>
		
		<p>While this is not <b>true</b> caching, Active Record enables you to save (or "cache") certain parts of your queries for reuse.
		Normally when an Active Record call is completed, all stored information is reset for the next call.  With caching, you can
		prevent this reset, and reuse the information.</p>

		<p>Cached calls are cumulative.  If you make two cached calls of <b>select()</b>, and then two uncached calls to <b>select()</b>
		this will result in four <b>select()</b> calls.  There are three caching methods available.</p>
	</div>

	<div class="content">
		<h1>$this->db->start_cache()</h1>
		
		<p>This method must be called to begin Active Record caching.  All Active Record queries of the correct type (below are the
		supported queries) are stored for reuse later.</p>
	</div>

	<div class="content">
		<h1>$this->db->stop_cache()</h1>
		
		<p>This method can be called to stop Active Record caching.</p>
	</div>

	<div class="content">
		<h1>$this->db->flush_cache()</h1>
		
		<p>This method deletes all items from the Active Record cache.</p>

		<div class="example">
			$this->db->start_cache();<br />
			$this->db->select('field1');<br />
			$this->db->stop_cache();<br />
			$this->db->get('tablename');<br />
			// give SELECT `field1` FROM (`tablename`)<br />
			<br />
			$this->db->select('field2');<br />
			$this->db->get('tablename');<br />
			// gives SELECT `field1`, `field2` FROM (`tablename`)<br />
			<br />
			$this->db->flush_cache();<br />
			<br />
			$this->db->select('field2');<br />
			$this->db->get('tablename');<br />
			// gives SELECT `field2` FROM (`tablename`)
		</div>

		<p><i>Note:</i> the following commands can be cached: select, from, join, where, like, group_by, having, order_by, and set.</p>
	</div>
</body>

</html>
